<?php
require('config-generator.php');
require('set-evx-hostname.php');
require('set-evx-interfaces.php');
require('set-evx-routing.php');
require('apply-configs.php');
require('core-details.php');
require('ip-tools.php');
require('json-tools.php');
require('update-core-router.php');
require('shell-controller.php');

$data = get_post_json();

if (isset($data['connection'])) {
    try {
        $connDetails = $data['connection'];
        setup_evx($connDetails);
        setup_core($connDetails);
        run_shell_script('../../scripts/removeTempFiles');
        send_json_success();
    } catch (Exception $e) {
        remove_team($connDetails['primary']);
        remove_team($connDetails['secondary']);
        send_json_error($e->getMessage());
    }
} else {
    send_json_error('No connection details provided');
}

function setup_evx($connDetails)
{
    // check current config
    check_current_details($connDetails['primary']);
    check_current_details($connDetails['secondary']);
    // create temp files uses config-generator.php
    create_files($connDetails['primary']);
    create_files($connDetails['secondary']);
     // move evx files from temp to working dir uses apply-config.php
    apply_evx_configs();
    // setup interfaces uses set-evx-interfaces.php
    set_default_interface_file();
    add_links_to_interfaces($connDetails['primary']['links']);
    add_firewall_to_interfaces($connDetails['primary']['wan']);
    update_ifplugd($connDetails['primary']['links']);
     // set up routing related configs uses set-evx-routing.php
    add_rtTables(count($connDetails['primary']['links']));
    setup_bgp($connDetails);
    // setup hostname uses set-evx-hostname.php
    set_hostname($connDetails['primary']['name']);

    return true;
}

function setup_core($connDetails)
{
    //setup primary core
    send_config_to_core($connDetails['primary']);
    create_openvpn_configs($connDetails['primary']);
    update_core_acl_team($connDetails['primary']);
    update_core_acl_links($connDetails['primary']);
    update_core_bgp($connDetails['primary']);
    start_team_on_core($connDetails['primary']);
    update_core_inuse_link_data($connDetails['primary']);
    update_core_inuse_team_data($connDetails['primary']);
    //setup secondary core
    send_config_to_core($connDetails['secondary']);
    create_openvpn_configs($connDetails['secondary']);
    update_core_acl_team($connDetails['secondary']);
    update_core_acl_links($connDetails['secondary']);
    update_core_bgp($connDetails['secondary']);
    start_team_on_core($connDetails['secondary']);
    update_core_inuse_link_data($connDetails['secondary']);
    update_core_inuse_team_data($connDetails['secondary']);

    return true;
}
