<?php

function mask2cidr($mask)
{
    $long = ip2long($mask);
    $base = ip2long('255.255.255.255');

    return 32-log(($long ^ $base)+1,2);        
}

function get_network_ip($ip, $netmask)
{
    $ip = ip2long($ip); 
    $netmask = ip2long($netmask);
    $network = ($ip & $netmask);

    return long2ip($network);
}

function get_broadcast_ip($ip, $netmask)
{
    $network = get_network_ip($ip, $netmask);
    $netmask = ip2long($netmask);    
    $broadcast = ip2long($network) | (~$netmask);

    return long2ip($broadcast);
}
