<?php

if (!function_exists("get_post_json")) {
    function get_post_json()
    {
        $inputJSON = file_get_contents('php://input');
        return json_decode($inputJSON, true);
    }

    function send_json($data)
    {
        header("Content-type:application/json");
        echo json_encode($data);
    }

    function send_json_success($payload = null)
    {
        $response = [
            "success" => true,
        ];

        if ($payload !== null) {
            $response['payload'] = $payload;
        }

        send_json($response);
    }

    function send_json_error($error_message, $error_code = 500, $payload = null)
    {
        $response = [
            "success" => false,
            "error" => [
                "code" => $error_code,
                "message" => $error_message
            ]
        ];

        if ($payload !== null) {
            $response['payload'] = $payload;
        }

        http_response_code($error_code);
        send_json($response);
    }
}
