<?php

function create_link_config($link)
{
    $config = 'ODEV=' . $link['name'] . '
PORT=' . $link['udp'] . '
LOG=/home/ev/logs/openvpn/' . $link['name'] . '.log
STATE=enable
UP=false
BANDWIDTH=100
WEIGHT=1
TARGET=10.10.' . $link['port'] . '.1
SOURCE=10.10.' . $link['port'] . '.2
ENCRYPTION=false';

    return $config;
}

function set_link_details($links, $redundancy)
{
    $lastTap = get_last_tap($redundancy);
    $lastUdp = get_last_udp($redundancy);
    $tap_prefix = ($redundancy === "primary") ? "tap" : "F_tap";
    return array_map(function ($link) use ($lastTap, $lastUdp, $tap_prefix) {
        return [
            'name' => $tap_prefix . ($lastTap + $link['linkNumber']),
            'udp' => $lastUdp + $link['linkNumber'],
            'port' => $link['linkNumber'],
            'interface' => $link['iface']
        ];
    }, $links);
}

function write_link_cfg($teamName, $linkNo, $config, $device)
{
    $file = "../../temp/" . $device . "/" . $teamName . "/port" . $linkNo . "/config";
    $fh = fopen($file, "w") or die("Unable to open file!");
    if (!fwrite($fh, $config)) {
        return false;
    }

    return fclose($fh);
}
