<?php

function set_default_interface_file(){
    $script = '../../scripts/createBaseInterfaces';
    $msg = run_shell_script($script);
    $msg = check_error_state($msg, "Setting Base interfaces File");
    if (!$msg['success']) {
        throw new Exception($msg['error']);
    }

    return true;
}

function add_links_to_interfaces($links)
{
    $script = '../../scripts/updateLinkInterfaces';
    foreach($links as $link){
        $msg = run_shell_script($script, $link['interface']);
        $msg = check_error_state($msg, "Setting Link interfaces File");
        if (!$msg['success']) {
            throw new Exception($msg['error']);
        }
    }
    return true;
}

function add_firewall_to_interfaces($firewall)
{
    $script = '../../scripts/updateFirewallInterface';
    $firewall = [
        'interface' => $firewall['interface'],
        'network' => get_network_ip($firewall['ip'], $firewall['subnet']),
        'address'=> $firewall['ip'],
        'broadcast'=> get_broadcast_ip($firewall['ip'], $firewall['subnet']),
        'netmask'=> $firewall['subnet']
    ];
    $firewall = array_to_string($firewall);
    $msg = run_shell_script($script, $firewall);
    $msg = check_error_state($msg, "Setting up firewall interface");
    if (!$msg['success']) {
            throw new Exception($msg['error']);
    }

    return true;
}

function update_ifplugd($links)
{
    $script = '../../scripts/updateIfplugd';
    $interfaces = array_map(function($link){
        return $link['interface'];
    }, $links);

    $interfaces = escapeshellarg(implode(' ', $interfaces));
    $msg = run_shell_script($script, $interfaces);
    $msg = check_error_state($msg, "Setting up ifplugd");
    if (!$msg['success']) {
            throw new Exception($msg['error']);
    }
    return true;    
}
