<?php

function add_rtTables($noLinks)
{
    $script = '../../scripts/updateRtTables';
    $msg = run_shell_script($script, $noLinks);
    $msg = check_error_state($msg, "Setting rt_tables");
    if (!$msg['success']) {
        throw new Exception($msg['error']);
    };
    return true; 
}

function setup_bgp($connDetails){
    try{
        set_evx_bgp($connDetails['primary'], 'primary', $connDetails['primary']['wan']);
        set_evx_bgp($connDetails['secondary'], 'secondary', $connDetails['secondary']['wan']);

        return true;
    } catch (Exception $e) {
        throw $e;
    }
}

function set_evx_bgp($team, $redundancy, $wanIp)
{
    $script = '../../scripts/setEvxBgp';
    $args = [
        'redundancy' => $redundancy,
        'coreTeamIp' => $team['team']['ip']['core'],
        'wanIp' => $wanIp['ip'],
        'subnet' => mask2cidr($wanIp['subnet'])
    ];
    $args = array_to_string($args);
    $msg = run_shell_script($script, $args);
    $msg = check_error_state($msg, "Setting up BGP for " . $redundancy . ' team');
    if (!$msg['success']) {
        throw new Exception($msg['error']);
    };

    return true;
}
