const LOAD_STATES = {
  UNLOADED: "unloaded",
  REQUESTED: "requested",
  LOADED: "loaded",
  LOAD_ERROR: "load error"
};

const initLoadState = (state = LOAD_STATES.UNLOADED) => ({
  state,
  error: null
})

function getLoadState(name) {
  const { loadStates } = STORE;
  const resource = loadStates[name];
  return resource !== undefined ? resource.state : undefined;
}

function getLoadError(name) {
  const { loadStates } = STORE;
  const resource = loadStates[name];
  return resource !== undefined ? resource.error : undefined;
}

function setLoadState(name, state, error = null) {
  const { loadStates } = STORE;
  const resource = loadStates[name];
  resource.state = state;
  resource.error = error;
}

const STORE = {
  develop: false,
  loadStates: {
    device: initLoadState(),
    primaryCore: initLoadState(),
    secondaryCore: initLoadState(),
    preparedConfig: initLoadState(),
    provision: initLoadState()
  },
  wizardStep: 'device-state',
  disableValidation: false,
  preparedConfig: {},
  device: {
    interfaces: []
  },
  connection: {
    basics: {
      name: "",
      deviceAsset: "",
      eviewId: ""
    },
    coreRouters: {
      primaryIp: "",
      secondaryIp: ""
    },
    wan: {
      interface: "eth0",
      ip: "",
      subnet: "255.255.255.252"
    },
    teams: {
      primary: {
        teamIpEvx: "",
        teamIpCore: ""
      },
      secondary: {
        teamIpEvx: "",
        teamIpCore: ""
      }
    },
    links: []
  }
};
