const FormCoreRouters = Vue.component("form-core-routers", {
  props: ["initialData"],
  data() {
    return {
      formData: Object.assign(
        {
          primaryIp: "",
          secondaryIp: ""
        },
        this.initialData
      )
    };
  },
  template: `
    <form @submit.prevent="onSubmit">
      <h2>Core Routers</h2>
      <ev-input
        label='Primary'
        v-model.trim='formData.primaryIp'
        :valid='validState.primaryIp'
        help='IP of the primary router'
        focus
      />

      <ev-input
        label='Secondary'
        v-model.trim='formData.secondaryIp'
        :valid='validState.secondaryIp'
        help='IP of the secondary router'
      />

      <input
        type="button"
        class="btn btn-primary"
        value="back"
        @click="$emit('back')"
      />
      <input
        class="btn btn-primary pull-right"
        type="submit"
        value="next"
        :disabled="!validState._allValid"
      />
    </form>
  `,
  methods: {
    validitor: createValiditor(V => ({
      primaryIp: [V.required, V.ipV4, V.differentFrom("secondaryIp")],
      secondaryIp: [V.required, V.ipV4, V.differentFrom("primaryIp")]
    })),
    onSubmit() {
      this.$emit("update", Object.assign({}, this.formData));
    },
    coreRequestState(core) {
      return core;
    }
  },
  computed: {
    validState() {
      return this.validitor(this.formData);
    },
    primaryRequestState() {
      this.coreRequestState(this.coreState.primary);
    }
  }
});
