Vue.component('status-device', {
  props: ['device', 'deviceState'],
  template: `
    <div>
      <h1>Device</h1>
      <div v-if="hasError">
        <p>There has been an error retriving information from this device.</p>
        <p>Error Message:</p>
        <p><strong>{{errorMessage }}</strong></p>
      </div>
    </div>
  `,
  computed: {
    hasError() {
      const { deviceState } = this;
      return deviceState.state === LOAD_STATES.LOAD_ERROR;
    },
    errorMessage() {
      const { deviceState } = this;
      return deviceState.error.message !== undefined ? deviceState.error.message : '';
    }
  }
});
